(******************************************************************)
(* Copyright 1997, Microchip Systems / Carl Bunton                *)
(* Email: Twojags@cris.com                                        *)
(* Web-page: http://www.concentric.net/~twojags                   *)
(*                                                                *)
(* This code is not for redistribution in whole or in part.  It   *)
(* may be used in compiled program format only.                   *)
(*                                                                *)
(* This program was written in Delphi 2 because version 2         *)
(* compiles a much smaller executable using the windows api.  It  *)
(* should be fully compatible with Delphi 3, but will produce a   *)
(* noticable increase of size in the final compiled program.      *)
(******************************************************************)
UNIT Dialog;


INTERFACE


USES
	Messages,
	Windows;



FUNCTION MainDialogProc( DlgWin     : hWnd ;
								  DlgMessage : UINT;
								  DlgWParam  : WPARAM ;
								  DlgLParam  : LPARAM  ) : BOOL; STDCALL;

FUNCTION FileExistsProc( DlgWin   	 : hWnd;
								  DlgMessage : UINT;
								  DlgWParam  : WPARAM;
								  DlgLParam  : LPARAM  ) : BOOL; STDCALL;

FUNCTION PwdProc( DlgWin     : hWnd;
						 DlgMessage : UINT;
						 DlgWParam  : WPARAM;
						 DlgLParam  : LPARAM  ) : BOOL; STDCALL;


                  
IMPLEMENTATION




USES
	SFXgbls,
  SFXmisc;


(*--------------------------------------------------------------------------*)
(*     FileExistsProc --- Handle messages for password dialog.              *)
(*--------------------------------------------------------------------------*)
FUNCTION FileExistsProc( DlgWin     : hWnd;
								  DlgMessage : UINT;
								  DlgWParam  : WPARAM;
								  DlgLParam  : LPARAM  ) : BOOL; STDCALL;
VAR
	Msg: STRING;

BEGIN

	 RESULT := TRUE;

	 CASE DlgMessage OF
		 WM_COMMAND    : CASE LOWORD( DlgWParam  ) OF

								  CM_YES, CM_NO:
                         				  BEGIN
																		 (* Noask Overwrite checked, show results in
                                                         affected option buttons *)

                                        IF SendMessage( GetDlgItem( DlgWin, CM_NOASK  ), BM_GETCHECK, 0, 0  ) = 1 THEN
                                        BEGIN
                                                      (* Set CM_CONFIRM to Unchecked *)

                                           SendMessage( GetDlgItem( MainWin, CM_CONFIRM  ),
                                                        BM_SETCHECK, 0, 0  );


                                           IF LOWORD( DlgWParam  ) = CM_YES THEN
                                           BEGIN

                                                      (* Set CM_OVERWRITE to checked *)

                                           	  SendMessage( GetDlgItem( MainWin, CM_OVERWRITE  ),
                                                        	BM_SETCHECK, 1, 0  );

                                                      (* Don't ask for OverWrites *)

 														  	  OverWriteMode := 0;
                                           	  OverWriteFile := TRUE;

                                           END ELSE BEGIN	(* CM_SKIP *)

                                                      (* Set CM_SKIP to checked *)

                                           	  SendMessage( GetDlgItem( MainWin, CM_SKIP  ),
                                                        	BM_SETCHECK, 1, 0  );

                                                      (* Don't ask... skip *)

 														  	  OverWriteMode := 1;
                                           	  OverWriteFile := FALSE;

                                           END;

 													  END ELSE
                                                                 (* Set Mode *)

                                        	  IF OverWriteMode > 0 THEN
                                        	  	  OverWriteFile := LOWORD( DlgWParam  ) = CM_OK;


      						  					  EndDialog( DlgWin, LOWORD( DlgWParam  )  );
                                        EXIT;

                                     END;

								  ELSE      ;

							  END (* CASE *);

		 WM_INITDIALOG : BEGIN
      					  	  CenterDialog( DlgWin  );
                         Msg := CurrentFile + '...already exists, overwrite?';
                         SendMessage( GetDlgItem( DlgWin, CM_EDIT1  ), WM_SETTEXT, 0, LONGINT( PCHAR( Msg  )  )  );
      					  END;

   END;

	 RESULT := FALSE;

END;


(*--------------------------------------------------------------------------*)
(*     PasswordProc --- Handle messages for password dialog.           *)
(*--------------------------------------------------------------------------*)
FUNCTION PwdProc( DlgWin     : hWnd;
							DlgMessage : UINT;
							DlgWParam  : WPARAM;
							DlgLParam  : LPARAM  ) : BOOL; STDCALL;
BEGIN

	 RESULT := TRUE;

	 CASE DlgMessage OF
		 WM_COMMAND    : CASE LOWORD( DlgWParam  ) OF

								  CM_OK     : BEGIN

													  PWLen := GetDlgItemText( DlgWin, CM_EDIT1, Password, fsMaxPassword  );
           									  //PwLen := SendMessage( GetDlgItem( DlgWin, CM_EDIT1  ), EM_GETLINE, 0, LONGINT( @Password  )  );
                                        Password[ PwLen ] := #0;

      						  					  //MessageBox( 0, Password, 'Password', mb_OK  );
      						  					  EndDialog( DlgWin, LOWORD( DlgWParam  )  );

                                     END;

								  ELSE      ;

							  END (* CASE *);
		 WM_INITDIALOG : BEGIN

												(* Center dialog on screen.       *)

								  CenterDialog( DlgWin  );

												(* Set input focus to the first   *)
												(* edit field.                    *)

								  SetFocus( GetDlgItem( DlgWin , CM_EDIT1  )  );

      					  END;

   END;

	 RESULT := FALSE;

END;



(*--------------------------------------------------------------------------*)
(*     MainDialogProc --- Handle messages for main window dialog.           *)
(*--------------------------------------------------------------------------*)
FUNCTION MainDialogProc( DlgWin     : hWnd ;
									DlgMessage : UINT;
								  	DlgWParam  : WPARAM ;
								  	DlgLParam  : LPARAM  ) : BOOL; STDCALL;

VAR
	 MyIcon : HICON;
   EditLen: LONGINT;

BEGIN (* MainDialogProc *)

	 RESULT := TRUE;

	 CASE DlgMessage OF

		 WM_INITDIALOG : BEGIN

 												(* Center dialog on screen.       *)

								  CenterDialog( DlgWin  );

												(* Set the icon for the program.  *)

								  MyIcon := LoadIcon( hInstance , 'MainIcon'  );
								  SetClassLONG( DlgWin , GCL_HICON , MyIcon  );

												(* Set input focus to the first   *)
												(* edit field.                    *)

								  SetFocus( GetDlgItem( DlgWin , CM_EDIT1  )  );

                                   (* Set ExtractPath to CurDir *)

                         GetCurrentDirectory( fsMaxPath, ExtPath  );
      						  //SetDlgItemText( DlgWin, CM_EDIT1, AppendDirTail( ExtPath  )  );
                         SendMessage( GetDlgItem( DlgWin, CM_EDIT1  ), WM_SETTEXT, 0, LONGINT( @ExtPath  )  );

                         				(* Hilite string in Edit1 control *)

                         SendMessage( GetDlgItem( DlgWin, CM_EDIT1 ), EM_SETSEL, 0, $7fff  );
                         //SendDlgItemMessage( DlgWin, CM_EDIT1, EM_SETSEL, 0, $7fff  );

                                   (* Set the first Checkbox as Checked *)

                         SendMessage( GetDlgItem( DlgWin, CM_SELECTALL  ), BM_SETCHECK, 1, 0  );
                         //CheckRadioButton( DlgWin, CM_SELECTALL, CM_SELECTNONE, CM_SELECTALL  );

                         				(* Set overwrite as default option button *)

  							  SendMessage( GetDlgItem( DlgWin, CM_CONFIRM  ), BM_SETCHECK, 1, 0  );
  							  //CheckRadioButton( DlgWin, CM_CONFIRM, CM_CONFIRM, CM_OVERWRITE  );
								  OverWriteMode := 2;  (* Confirm *)


                         				(* Set CM_STOREDPATH to Checked *)

                         SendMessage( GetDlgItem( DlgWin, CM_STOREDPATH  ),
                         	  BM_SETCHECK, 1, 0  );

 								  				(* Fill the list box *)

      						  ProcessArchive( DlgWin, TRUE  );

                         				(* Select all items in the listbox *)

  							  SendMessage( GetDlgItem( DlgWin, CM_FILELIST  ), LB_SETSEL, 1, -1  );

                         				(* Assign to a global *)

                         MainWin := DlgWin;

							  END;

												(* Handle button presses, etc. *)

		 WM_COMMAND    : CASE LOWORD( DlgWParam  ) OF

      						  CM_STOREDPATH: BEGIN

                                           ProcessArchive( DlgWin, TRUE  );

                                           			(* Disable the edit control *)

                                           //EnableWindow( GetDlgItem( DlgWin, CM_EDIT1  ),
                                           //	  SendMessage( GetDlgItem( DlgWin, CM_STOREDPATH  ), BM_GETCHECK, 0, 0  ) <> 1  );

                                                  (* Select all items in the listbox *)

                                           //IF IsDlgButtonChecked( DlgWin, CM_SELECTALL  ) = 1 THEN
                                           //   SendDlgItemMessage( DlgWin, CM_FILELIST, LB_SETSEL, 1, -1  );
                                           IF SendMessage( GetDlgItem( DlgWin, CM_SELECTALL  ), BM_GETCHECK, 0, 0  ) = 1 THEN
                                           	  SendMessage( GetDlgItem( DlgWin, CM_FILELIST  ), LB_SETSEL, 1, -1  );

                         					  END;

								  CM_SELECTALL:

  											(* Select all items in the listbox *)

  								  SendMessage( GetDlgItem( DlgWin, CM_FILELIST  ), LB_SETSEL, 1, -1  );

								  CM_SELECTNONE:

  											(* Unselect all items in the listbox *)

   								  SendMessage( GetDlgItem( DlgWin, CM_FILELIST  ), LB_SETSEL, 0, -1  );

      						  CM_OVERWRITE	: OverWriteMode := 0;
                         CM_SKIP		: OverWriteMode := 1;
                         CM_CONFIRM	: OverWriteMode := 2;

								  CM_OK     : BEGIN

													  EditLen := GetDlgItemText( DlgWin, CM_EDIT1, ExtPath, fsMaxPath  );
                         					  //EditLen := SendMessage( GetDlgItem( DlgWin, CM_EDIT1  ), EM_GETLINE, 0, LONGINT( @ExtPath  )  );
                                        ExtPath[ EditLen ] := #0;

                                        IF ExtPath = '' THEN
                                        BEGIN
                                           GetCurrentDirectory( fsMaxPath, ExtPath );
                                           //SetDlgItemText( DlgWin, CM_EDIT1, ExtPath  );
                                           SendMessage( GetDlgItem( DlgWin, CM_EDIT1  ), WM_SETTEXT, 0, LONGINT( @ExtPath  )  );
                                        END;

                                     	  ProcessArchive( DlgWin, FALSE  );

												  END;

								  CM_CANCEL : BEGIN

													  EditLen := GetDlgItemText( DlgWin, CM_EDIT1, ExtPath, fsMaxPath  );
           									  //EditLen := SendMessage( GetDlgItem( DlgWin, CM_EDIT1  ), EM_GETLINE, 0, LONGINT( @ExtPath  )  );
                                        Extpath[ EditLen ] := #0;

                                        IF FileExists( ExtPath  ) THEN
                                        	  SetCurrentDirectory( ExtPath  );

													  EndDialog( DlgWin, LOWORD( DlgWParam  )  );
													  EXIT;

												  END;

								  ELSE      ;

							  END (* CASE *);

		 ELSE          ;

	 END (* CASE *);

	 RESULT := FALSE;

END   (* MainDialogProc *);
(*--------------------------------------------------------------------------*)



END.
